/* --------------------------------------------------------
   BPEňksvO
                                    2003/08/31
                                         S.Mio
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* õf[^ */
unsigned char datastr[] = 
    "=*@=-@---**W   @=**-  `@---@-=@+#-=---@***+X8@@#@@----=***=X@+="
    "*XW-8H--=**@   *+*=W   `@=--@---#@@@@@@=#8***---X@@@8--=*****##"
    "*#H=@---=**@   .H*+@     -#--@-@@@-  -@@@@#@**+--=*@X=@X=*****8"
    "*@**W---=**@    @+*8.      *=+@@+   @8####@@@H***--*@8---+*****"
    "*@*H#---=**@`   #=*+8       .@@-    @#######@@@@X*=-*@X---*****"
    "*@H@8@@-=**W`   `8++@       #@=    `@######W@= `@@W*+8@---=****"
    "8@X#@@@-W**8-    #-*8,      @@      W@######@H   @X@#*@@---****"
    "8#=@@@,=@@**@     @+=@      -@        8W#8X8W@   @@`-@@@---****"
    "-=#@@@ =@W@*8-    `8+W.      @         @#8HH##@@@WWW.#@@---****"
    "--@@@@  @##@#W`     #-#      `@        .@#8XH8W@@##@- @@---****"
    "--+@@@   W#@-@W      ,-`                @#8XXX8@@W#@ -@@---****"
    "--+@@@-   @#@ @ #      `                #W#XXXH####W @ *--=****"
    "--+@-8@    @#@`@                        -@#XXXX8####@ @---+****"
    "--=@*#-,    @#@@@            ```` @     `@#XXXXH8@@W=X---=*****"
    "--=@X*#* -   @#W@@           ````  XW@-``@####8@, .8W---=******"
    "--=WH**8#`-   W*#@#                              ,@----+*******"
    "---8#**+=@     @XX8        =XX                  =#---=*********"
    "---=@*@- `@  8  @X@       +   @               `@*--=***********"
    "----@X@.  #+  H+-         @    =, _@         -@--**=****++****W"
    "@---=#=#- -@              =`     @         -@X*W@@@@@@@@@WXX#@X"
    "*H8--W=--@=@             -@@      ,-     `@X+@@H----@H--+#@@@8X"
    "***@X--@8--@W,              @       @   @X@#@-----@@````````-X@"
    "-=***8@@8HW@@@@@@X,`         @       @@H--------@@.,-,`````````"
    "---*******@=*H-=**X#@@@8-.    @        ,@-----@#--===-,````````"
    "----=*****@X=@----==***8#-#W@@W,@        .@=*8,-======,````````"
    "------+***##-@------=***##*W@X=X@@*-    @`  -@W-======,````````"
    "-------+**X@-H@------+***#W*@@======H#@`      -@8@====--..`````"
    "--X@@@@WX**#8=@W------+***@@@@*====WX`        =+  @-=====------"
    "#        ##+@-8##------=*#@H@@H===@`        -8     `@@@@@@@X-=="
    "          `@8@-@*W---H@@@8+==*@H=+#        8-        @@@    -@X"
    "             `,-8-@@@8=======##8@#@      `@        @,   `-    `"
    "                `#@*=========@    `@    `@       -8            ";

unsigned int  paircountbuf[256][256];   /* yȀopJE^ */
unsigned char pairtable_1st[256];       /* yA\(1Ԗڂ̕)  */
unsigned char pairtable_2nd[256];       /* yA\(2Ԗڂ̕)  */
unsigned char srcbuf[2048];             /* k͈͂̃f[^ */

void dumpprint(unsigned char *p, int size);

/* -------------------------------------------------------- */
/* yA\kf[^i[ */
int set_encodedata(unsigned char *dest, int srcsize)
{
    int destsize = 0, i;
    unsigned char *countpos;
    int count;
    
    countpos = dest;
    dest++;
    destsize++;
    count = 0;

    for (i = 0; i < 256; i++) {
        if (pairtable_1st[i] != i) {
            dest[0] = (unsigned char)i;
            dest[1] = pairtable_1st[i];
            dest[2] = pairtable_2nd[i];
            dest += 3;
            destsize += 3;
            count++;
        }
    }
    *countpos = (unsigned char)(count-1);
    memcpy(dest, &srcsize, 2);
    dest += 2;
    destsize += 2;
    memcpy(dest, srcbuf, srcsize);
    destsize += srcsize;
    return destsize;
}

/* k */
int encode(unsigned char *dest, unsigned char *src, int srcsize)
{
    int i, j, srcount, destcount, desttotalcount;
    int srcbufsize, c, c1, c2, encch, srcpos, destpos;
    unsigned int maxcount;
    
    desttotalcount = 0;
    do {
        /* yA\ */
        for (i = 0; i < 256; i++) {
            pairtable_1st[i] = i;
            pairtable_2nd[i] = 0;
        }

        /* k͈͂̃f[^Rs[ */
        if (srcsize < sizeof(srcbuf)) {
            srcbufsize = srcsize;
        } else {
            srcbufsize = sizeof(srcbuf);
        }
        memcpy(srcbuf, src, srcbufsize);
        src += srcbufsize;
        srcsize -= srcbufsize;

        /* eyA\ɓo^ */
        for (i = 0; i < srcbufsize; i++) {
            c = srcbuf[i];
            pairtable_1st[c] = c;
            pairtable_2nd[c] = 1;
        }

        do {
            /* yȀopJE^쐬 */
            for (i = 0; i < 256; i++) {
                for (j = 0; j < 256; j++) {
                    paircountbuf[i][j] = 0;
                }
            }
            for (i = 0; i < (srcbufsize / 2) * 2; i+=2) {
                c1 = srcbuf[i];
                c2 = srcbuf[i+1];
                paircountbuf[c1][c2]++;
            }
            
            /* Ƃ悭oyA𓾂 */
            maxcount = 0;
            for (i = 0; i < 256; i++) {
                for (j = 0; j < 256; j++) {
                    if (maxcount < paircountbuf[i][j]) {
                        maxcount = paircountbuf[i][j];
                        c1 = i;
                        c2 = j;
                    }
                }
            }
            /* yA̐3ȉȂ爳k~߂ */
            if (maxcount <= 3)
                break;
            
            /* gĂȂencch𓾂 */
            encch = -1;
            for (i = 0; i <= 255; i++) {
                if ((pairtable_1st[i] == i) &&
                    (pairtable_2nd[i] == 0)) {
                    encch = i;
                    break;
                }
            }
            /* ȂȂ爳k~߂ */
            if (encch == -1)
                break;
            
            /* yAencchɒu */
            srcpos = 0;
            destpos = 0;
            while (srcpos < srcbufsize) {
                if ((srcbuf[srcpos] == c1) && (srcbuf[srcpos+1] == c2)) {
                    srcbuf[destpos] = encch;
                    destpos++;
                } else {
                    srcbuf[destpos] = srcbuf[srcpos];
                    destpos++;
                    /* obt@Rs[i߂Ȃ悤ɂ */
                    if (srcpos+1 < srcbufsize) {
                        srcbuf[destpos] = srcbuf[srcpos+1];
                        destpos++;
                    }
                }
                srcpos += 2;
            }
            srcbufsize = destpos;

            /* yA\ɐݒ */
            pairtable_1st[encch] = c1;
            pairtable_2nd[encch] = c2;

        } while(srcbufsize > 0);

        /* kς݃f[^dest֓ */
        destcount = set_encodedata(dest, srcbufsize);
        dest += destcount;
        desttotalcount += destcount;
    } while(srcsize > 0);
    return desttotalcount;
}

/* kf[^yA\ƈkf[^̒𓾂 */
int get_decodedata(unsigned char *src, int *srcsize)
{
    int i, pos, destsize;
    unsigned char count;
    
    count = *src;
    src++;
    destsize = 1;
    for (i = 0; i < 256; i++) {
        pairtable_1st[i] = i;
        pairtable_2nd[i] = 0;
    }
    for (i = 0; i <= count; i++) {
        pos = src[0];
        pairtable_1st[pos] = src[1];
        pairtable_2nd[pos] = src[2];
        src += 3;
        destsize += 3;
    }
    memcpy(srcsize, src, 2);
    destsize += 2;
    return destsize;
}

/* WJ */
int decode(unsigned char *dest, unsigned char *src, int srcsize)
{
    int i, destcount, srccount, srcbufsize, stackhead, ch1st, ch2nd;
    unsigned char stackbuf[128];
    unsigned char *srcp;
    unsigned char ch;

    destcount = 0;
    do {
        /* f[^ǂݍ */
        srccount = get_decodedata(src, &srcbufsize);
        srcp = src + srccount;
        src += srccount + srcbufsize;
        srcsize -= srccount + srcbufsize;
        stackhead = 0;
        
        /* f[^WJ */
        do {
            if (stackhead == 0) {
                /* f[^1oCgǂݍ */
                ch = *srcp;
                srcp++;
                srcbufsize--;
            } else {
                /* X^bN1oCgǂݍ */
                stackhead--;
                ch = stackbuf[stackhead];
            }

            /* yA\當𓾂 */
            ch1st = pairtable_1st[ch];
            ch2nd = pairtable_2nd[ch];

            if (ch1st == ch) {
                /* f[^1oCgo */
                *dest = ch;
                dest++;
                destcount++;
            } else {
                /* f[^X^bN֓ */
                stackbuf[stackhead] = ch2nd;
                stackhead++;
                stackbuf[stackhead] = ch1st;
                stackhead++;
            }
        } while(srcbufsize > 0);
    } while(srcsize > 0);
    return destcount;
}

/* -------------------------------------------------------- */
/* WJf[^̕\ */
void dataprint(unsigned char *p, int size)
{
    unsigned char buf[64 + 1];
    int y, copysize;
    
    for (y = 0; y < 32; y++) {
        copysize = (size < 64-1) ? size : 64-1;
        memcpy(buf, p, copysize);
        size -= copysize;
        buf[copysize] = '\0';
        printf("%s\n", buf);
        p += 64-1;
        if (!size)
            break;
    }
}

/* WJf[^̃_v\ */
void dumpprint(unsigned char *p, int size)
{
    int i;

    for (i = 0; i < size; i++) {
        if ((i % 16) == 0)
            printf("\n");
        if ((i % 256) == 0)
            printf("\n");
        printf("%02x ", *p);
        p++;
    }
}

/* -------------------------------------------------------- */
int main(void)
{
    /* k/WJobt@ƍƗpϐ */
    unsigned char encbuf[1024*10];
    unsigned int  enccount;
    unsigned char decbuf[64 * 32 + 1];
    unsigned int  deccount;

    printf("̃f[^:     %dbyte\n", sizeof(datastr));
    
    /* k */
    enccount = encode(encbuf, datastr, sizeof(datastr));

    printf("kf[^: %dbyte\n", enccount);
    dumpprint(encbuf, enccount);

    /* WJ */
    deccount = decode(decbuf, encbuf, enccount);
    
    printf("\nWJf[^: %dbyte\n\n", deccount);
    dataprint(decbuf, deccount);
    return 0;
}
